;Hangkrtya meghajtsa DMA-val
;sound card: DMA1 , IRQ5

;A file-bl egyetlen szegmenset, 64kB-ot jtszik le
%include "bnd_mac.h"
%include "bndfile.h"
sz1 db 'Sound Card driver with DMA',10,13,0
sz2 db 'Interrupt was detected',10,13,0
err1 db 'Memory allocation error',10,13,0
err2 db 'Error reading the file',10,13,0
err3 db 'Sound Card is not exist',10,13,0
poi dw 0;pointer to the allocated mem.
file1 db 'd:\media\zene\letmebe2.wav',0
freq dw 20000; sample frequency [Hz]
mszak dd 0;int 0DH rgi rtke
mask db 0; interrupt mask

inte:;IRQ5 interrupt routine
push ax
push ds
push dx
mov ax,cs
mov ds,ax
cli
mov al,20h
out 20h,al
sti
mov dx,22Eh;read the state
in al,dx
putbs 0,sz2
ring
pop dx
pop ds
pop ax
iret

initsound:;reset and control
mov dx,226h
mov al,1
out dx,al
delay 10,10
mov al,0
out dx,al
delay 10,10
mov dx,22Eh
in al,dx
test al,80H
jz serr
mov dx,22Ah
in al,dx
cmp al,0AAh
jnz serr
ret
serr:
putbs 0,err3;not exist
end

writedsp:; al=data
push ax
varas1:
mov dx,22Ch
in al,dx
test al,80H
jnz varas1
pop ax
out dx,al
ret

readdsp:;al=data
mov dx,22Eh
in al,dx
test al,80h
jz readdsp
mov dx,22Ah
in al,dx
ret

speakeron:;bekapcsols
mov al,0D1h
call writedsp
ret

speakeroff:
mov al,0D3h
call writedsp
ret

dmastop:
mov al,0D0h
call writedsp
ret

dmacontinue:
mov al,0D4h
call writedsp
ret

start:;****************  START*******************************************
clrscr
putbs 0,sz1
mov ax,4A00h; memory rename : CODE SEGMENT=64kB
mov bx,4096
int 21h
push cs
pop ss
mov ax,0fffdh
mov sp,ax
jc hiba
mov ax,4800h; asking for 192kB memory
mov bx,12288
int 21h
jc hiba;ax=pointer
add ax,4096; computing the DMA puffer address
mov dx,0;    DMAseg=((allocated_seg)div 4096)*4096
mov bx,4096
div bx
mul bx
push cs
pop ds
mov [poi],ax;save the pointer
jmp at001
hiba:
putbs 0,err1
end

at001:
open1r
read1 50,puffer1
read1 32768,puffer1;read data
cld
mov cx,16384
mov si,puffer1
mov ax,[poi]
mov es,ax
mov di,0
rep movsw
mov ax,cs
mov ds,ax
read1 32768,puffer1;read data
cld
mov cx,16384
mov si,puffer1
mov ax,[poi]
mov es,ax
mov di,32768
rep movsw
mov ax,cs
mov ds,ax
close1
delay 100,100

;*****************Init for playing**************************************
;INTERRUPT SETTINGS
cli
xor ax,ax;save and set interrupt vector
mov ds,ax
mov ax,[0Dh*4]
mov [es:mszak],ax
mov ax,[0Dh*4+2]
mov [es:mszak+2],ax
mov ax,inte
mov [0Dh*4],ax
mov [0Dh*4+2],cs
push cs
pop ds
;set interrupt mask register
in al,21h
mov [mask],al;save mask
and al,11011111b
out 21h,al;set mask , IRQ5 = Enabled
sti
;DMA SETTING
call speakeron
mov al,01h;[dmach]
add al,04h
out 0Ah,al;mask reg.
mov al,0
out 0Ch,al;Clear the internal DMA flip-flop
mov al,01h;[dmach]
add al,48h
out 0Bh,al; Mode reg.
mov ax,[poi];cmszmts
mov bx,16
mul bx;dx:ax= lin cm
out 02h,al; lin cm als 8 bit
mov al,ah
out 02h,al; lin cm kv 8  bit
mov al,dl
out 83h,al;page reg.
mov al,0FFh;size
out 03h,al;size low
mov al,0FFh
out 03h,al;size high
mov al,01h
out 0Ah,al;mask reg = enable DMA
;DSP SETTING
mov al,40h; set the sample rate
call writedsp
mov dx,15
mov ax,16960
mov bx,[freq]
div bx
mov dx,256
sub dx,ax
mov al,dl
call writedsp; 256 - 1 000 000 Div Freq
mov al,14h;8 bit playing with DMA
call writedsp
mov al,0feh; size low
call writedsp
mov al,0ffh;size high
call writedsp
jmp at102

err22:
putbs 0,err2
end

at102:
mov ax,0;bill vrs
int 16h
mov ax,4900h; free
mov bx,[poi]
mov es,bx
int 21h
xor ax,ax; restore interrupt vector
mov ds,ax
push cs
pop es
cli
mov ax,[es:mszak]
mov [0Dh*4],ax
mov ax,[es:mszak+2]
mov [0Dh*4+2],ax
mov ax,cs
mov ds,ax
;restore interrupt mask
mov al,[mask]
out 21h,al
sti
end

puffer1: