;****************************************************************
;   FILTERING for C language
;   Digital Signal Processing modules
;   Copyright(c) Bognr Andrs   -  Quenne Electric
;****************************************************************

;16 bit Digital filtering

[BITS 16]		;Set code generation to 16 bit mode
[SEGMENT .text]		;Main code segment

GLOBAL _filter
EXTERN _h               ;h parameters (Coeffitients): 16X floats
EXTERN _cbuf            ;circle buffer: 16X integers
EXTERN _norm            ;normalizer factor: 1X float

cpy db 'Copyright(c) Bognr Andrs 2006',0
cpoi dw 0               ;circle buffer pointer [offs]
res dw 0                ;result

_filter:
pusha
mov bp,sp
;circling
mov si,[cs:cpoi]
mov ax,[bp+20]          ;INPUT adat=dx
mov [_cbuf+si],ax       ;adat letrolsa
add si,2
and si,001Fh            ;inkrementls, cirkularizls
mov [cs:cpoi],si
;filtering
finit
fldz                    ;init
mov cx,16
xor di,di               ;di=coeff pointer
c_fir:
fild word [_cbuf+si]
add si,2                ;pointer incrementing
and si,001Fh
fmul dword [_h+di]
add di,4
faddp st1,st0
loop c_fir
;normalizing
fmul dword [_norm]
fist word [cs:res]
popa
mov ax,[cs:res]
retf
