;***********************************************************************
;*                                                                     *
;*                    8 Bit Sound Player and Recorder                  *
;*                                                                     *
;*                   Copyright(c) Bognr Andrs  2005                  *
;*                                                                     *
;*  Uses 8 bit DMA, Sound Blaster 16 or Pro ,PORT 220H , DMA1, IRQ5    *
;*  Simple user interface,  written for DOS, WIN3.XX, WIN95            *
;***********************************************************************
%include "bnd_mac.h"      ;BND system service header file
%include "sound.h"        ;Sound driver header file
;Row summary:
;   magno.asm   940 rows
;   bnd_mac.h   142 rows
;   bnd.asm     837 rows
;   sound.h     150 rows
;   summary=    2069 rows
sz1 db 'Sound Card driver with DMA',10,13,0
sz2 db 'Interrupt was detected',10,13,0
sz3 db 'Input file to play: ',0
sz4 db 'Copyright(c) Bognr Andrs 2005',0
sz5 db 'Vlasszon egy funkcit!',0
smpl db 'Mintavteli frekvencia[Hz]=',0
opensz db 'Megnyitand file neve:',0
pl_sz db 'PLAYING',0
rec_sz db 'RECORDING',0
bck db 'BLOCK',0
pause_sz db 'PAUSE / SZNET',0
err1 db 'Memory allocation error',10,13,0
err2 db 'Error reading the file',10,13,0
err3 db 'Error opening the file',0
err4 db 'Error writing the file',10,13,0
poi dw 0                  ;pointer to the allocated mem.
mem dw 0                  ;segment of the allocated memory
file db 0,0,0,0,0,0,0,0,0,0,0,0,0;file name string
fileno dw 0               ;file handling number
lastblock db 0            ;=1 if last block is played
blocksize dw 0            ;size of the played block
blockno dw 1              ;number of the played block
block_ud db 1             ;upper(2) or lower(1) 64kB is played
phase db 1                ;recoirding block phase
freq dw 20000             ;sample frequency [Hz]
volume db 08h             ;mixer volume level
mszak dd 0                ;int 0DH old value
mask db 0                 ;interrupt mask
play_flag db 0            ;set during the playing
record_flag db 0          ;set during the recording

i1 db 'ESC GOMB:',0
i2 db 'LE NYL:',0
i3 db 'JOBBRA NL:',0
i4 db 'BALLRA NYL:',0
i5 db 'FEL NYL:',0
i6 db 'SPACE:',0
i7 db 'S GOMB:',0
i8 db '- GOMB:',0
i9 db '+ GOMB:',0
i10 db 'BACKSPACE:',0
i0 db 'O GOMB:',0

i11 db 'kilps',0
i12 db 'lejtszs',0
i13 db 'prgets elre',0
i14 db 'prgets htra',0
i15 db 'stop',0
i16 db 'pause/sznet',0
i17 db 'mintavteli frekv.',0
i18 db 'hanger cskken',0
i19 db 'hanger n',0
i20 db 'felvtel',0
i00 db 'file megnyitsa',0

bill:;-------------------Keyboard routine for playing-----------------------
;For there was a keystroke during the playing this function asks for the
;keycode and calls the function belonged to .
mov ax,0               ;asking for the key code , BIOS calling
int 16h
cmp al,27              ;ESC -leave the program
jz escape1
cmp ah,75              ;Left arrow  -turn back
jz back1
cmp ah,77              ;Right arrow -turn forward
jz forward1
cmp al,' '             ;space  -pause
jz szunet1
cmp al,'-'             ;decrease volume
jz vol_min1
cmp al,'+'             ;increase volume
jz vol_plus1
cmp ah,72              ;Up arrow -stop playing
jz stop1
ret
;Jump table   -playing
escape1: jmp escape   ;leave the program
back1: call back      ;turn back
ret
forward1: call forward;turn forward
ret
szunet1: call szunet  ;pause, waiting
ret
vol_min1: call vol_min;decrease the volume
ret
vol_plus1: call vol_plus;increase the volume
ret
stop1: jmp stop       ;stop playing

bill_r:;-------------------Keyboard routine for playing----------------------
;For there was a keystroke during the recording this function asks for
;the keycode and does which belonges to it.
mov ax,0               ;ask BIOS for the keycode
int 16h
cmp al,' '             ;space
jz szunet2             ;call Pause routine
cmp ah,72              ;Up arrow -stop recording
jz stoprecord
ret
stoprecord:            ;stop the recording
pop ax                 ;empty the stack
pop ax
call dmastop           ;stop the DMA operation in the DSP
mov al,01h             ;disable DMA CH1
add al,04h
out 0Ah,al
mov ax,cs              ;save the last block
mov ds,ax
mov al,[phase]         ;according to the variable [phase] we save the upper
cmp al,1               ;or the lower 64kB block
jz first_b
call save2             ;save the upper block
jmp at201
first_b:
call save1             ;save the lower block
at201:                 ;close the file
mov bx,[fileno]
mov ah,3Eh
int 21h
jc ferrorw5            ;error handling
mov al,1
mov [phase],al         ;set the [phase] variable to the first block
mov al,0
mov [record_flag],al   ;recording ends, set record_flag=0
call delwin            ;set the CRT
setcolor 15
puts 5,10,sz5
jmp ask_bill           ;recording ends
ferrorw5: pop ax       ;file error handler
jmp ferrorw

szunet2: call szunet   ;call the pause routine
ret

escape:;-------------------Stop playing and exit--------------------------
; If the ESC key was hit, this routine will run.
;  You can hit ESC anywhen.
call dmastop             ;stop the DMA operation in the DSP
mov al,05h               ;stop DMA
out 0Ah,al
mov ah,3Eh               ;close the file
mov bx,[fileno]
int 21h
jc ferror22
jmp at010
ferror22: push ax       ;file error
jmp ferror
at010:
jmp vege

back:;------------------------Play back-------------------------------------
;If the Left arrow was hit during the playing this routine will run
;It resets the playing the actual 64kB block.
call dmastop            ;stop DSP
mov dx,226h             ;reset the sound card , write the reset port
mov al,1
out dx,al
delay 10,10
mov al,0
out dx,al
delay 10,100            ;critical delay !
mov al,[block_ud]       ;reset upper or lower block is played?
cmp al,1
jz lower_rst
mov bx,4096            ;we have to load 4096 to BX for the upper block
call set_play          ;play again the upper block
jmp at789
lower_rst:
mov bx,0               ;we have to load 0 to BX for the upper block
call set_play          ;play again the lower block
at789:
mov al,0               ;clear interrupt flag
mov [flag],al
ret

forward:;-------------------Turn forward with a block---------------------
;If the Right arrow was hit during the playing this routine will run.
;It will start playing the next 64kB block of the file
mov al,[lastblock]       ;if the last block is played it can't run
cmp al,1
jz fw_01
mov al,1                 ;it seems to make an interrupt
mov [flag],al
call dmastop             ;disable DSP
mov al,05h               ;disable DMA
out 0Ah,al
mov dx,226h              ;reset the sound card
mov al,1
out dx,al
delay 10,10
mov al,0
out dx,al
delay 10,100             ;critical delay !
mov al,01h               ;enable DMA
out 0Ah,al
fw_01:
ret

szunet:;-------------------------Pause-------------------------------------
;If the Space was hit during the playing this routine will run.
;It pauses the playing or recording it waits for a next keystroke
call dmastop        ;stop DSP
call delwin         ;Print to CRT 'PAUSE'
setcolor 15
puts 10,10,pause_sz
mov ax,0            ;waiting for a keystroke
int 16h
call delwin         ;restore the CRT
setcolor 15
puts 10,10,pl_sz
puts 5,20,bck
mov ah,2             ;set cursor position with BIOS
mov bh,0
mov dl,12
mov dh,20
int 10h
mov ax,[blockno]
mov dx,0
decimal
call dmacontinue     ;enable DSP playing, continue playing
ret

vol_min: ;------------------------Decrease the volume-----------------------
;If the Key '-' was hit during the playing this routine will run.
;It decreases the DSP output volume and the general output volume
mov al,[volume]     ;ask the actual volume into AL
cmp al,0            ;if the volume is zero then don't decrease
jz vm_01
dec al              ;decrease the volume in AL
mov [volume],al     ;save the volume
jmp vol_05          ;jmp to the finish
vol_plus:;------------------------Increase the volume-----------------------
;If the Key '+' was hit during the playing this routine will run.
;It increases the DSP output volume and the general output volume
mov al,[volume]     ;ask the actual volume to AL
cmp al,0fh          ;if the volume is maximal(0FH) then don't increase
jz vm_01
inc al              ;increase the volume in AL
mov [volume],al     ;save the volume
vol_05:             ;Routine ends
mov al,[volume]     ;write the volume set into the Sound Card registers
mov ah,al           ;Be the lower and the higher 4bit of AL the same
shl ah,4
or al,ah
mov ah,04
call mixer          ;Write the volume level to the DSP output level reg.
mov ah,22h
call mixer          ;Write the volume level to the General output register
vm_01:
ret

stop:;---------------------Stop playing---------------------------------
;If the Key '-' was hit during the playing this routine will run.
;It stops the playing 
mov ax,cs
mov ds,ax
call dmastop             ;Stop the DSP
mov al,05h               ;stop the DMA
out 0Ah,al
mov al,[lastblock] ;if it's the last block then don't close the file again
cmp al,1
jz at011
mov ah,3Eh               ;close the file
mov bx,[fileno]
int 21h
jc ferror23
jmp at011
ferror23: push ax       ;file error
jmp ferror
at011:
jmp abort_play
ret

delwin:;------------------Delete window-----------------------------------
;Delete the left part of the CRT window
;It puts Spaces (32) to the CRT with two cycle.
setchar 32             ;We put spaces into the screen
setcolor 7             ;the color is grey
mov cx,23              ;We have 23 rows
mov ax,1
sss:                   ;external cycle
push cx
mov cx,39              ;We have 39 coloumns
mov dx,1
ooo:                   ;internal cycle
putchar dl,al ;Put the caracter to the screen coords X,Y
inc dx                 ;increase X coord
loop ooo
pop cx
inc ax                 ;increase Y coord
loop sss
ret

keret:;-----------------------Print instructions---------------------------
;Set the CRT screen , it makes the frame, and prints the instructions
clrscr                ;clear the screen
setchar 219           ;make the frame
setcolor 2
mov cx,80
sor1:
push cx
dec cx
putchar cl,0
putchar cl,24
pop cx
loop sor1
mov cx,24
oszlop1:
putchar 0,cl
putchar 79,cl
loop oszlop1
setcolor 6
mov cx,23
oszlop2:
putchar 40,cl
loop oszlop2
setcolor 15            ;Print the instructions and the copyright
puts 42,2,i1
puts 42,3,i2
puts 42,4,i3
puts 42,5,i4
puts 42,6,i5
puts 42,7,i6
puts 42,8,i7
puts 42,9,i8
puts 42,10,i9
puts 42,11,i10
puts 42,12,i0
setcolor 7
puts 55,2,i11
puts 55,3,i12
puts 55,4,i13
puts 55,5,i14
puts 55,6,i15
puts 55,7,i16
puts 55,8,i17
puts 55,9,i18
puts 55,10,i19
puts 55,11,i20
puts 55,12,i00
setcolor 6
mov cx,39
mov bx,40
sor2:
putchar bl,14
inc bx
loop sor2
setcolor 14
puts 42,18,sz4
setcolor 15
puts 5,10,sz5
ret

sample:;---------------------Set sample rate-------------------------------
;If the 'S' Key was hit this routine will run
;It sets the sample rate
call delwin
setcolor 15
puts 3,10,smpl
mov ah,2             ;set cursor position
mov bh,0
mov dl,5
mov dh,11
int 10h
setcolor 7
indec               ;Read the sample rate number from the keyboard
jc at233            ;Jump if error
cmp dx,0
jnz at233           ;Jump if it's more then 255
mov [freq],ax       ;save the sample rate
at233:
call delwin         ;Don't set anything if there was an error
setcolor 15         ;restore the CRT
puts 5,10,sz5
ret

open:;-----------------------Open the file---------------------------------
;If the Key '0' or 'O' was hit then this routine will run.
;It reads the file name from the keyboard
call delwin           ;set the CRT
setcolor 15
puts 3,10,opensz      ;Put the question
setcolor 7
mov ah,2              ;set the cursor position
mov bh,0
mov dl,5
mov dh,11
int 10h
getbs 15,file         ;Get the file name from the keyboard 
cld
mov di,file           ;search zero (end of string)
mov al,0
mov cx,9
repnz scasb
dec di     ;You have to write in only the name of the file, you don't have
mov al,'.' ;to write the extension of the file.
mov [di],al;Complete with the  .wav file extension
mov al,'w'
inc di
mov [di],al
mov al,'a'
inc di
mov [di],al
mov al,'v'
inc di
mov [di],al
mov al,0
inc di
mov [di],al
call delwin       ;restore the CRT
setcolor 15
puts 5,10,sz5
ret

read_high:;----------------Load high 64kB block---------------------------
;Load the next 64kB block of the file to the DMA buffer higher area
mov ax,[poi]     
add ax,4096       ;AX=DMA buffer address
jmp at003
read_low:;-----------------Load low 64kB block----------------------------
;Load the next 64kB block of the file to the DMA buffer lower area
mov ax,[poi]      ;AX=DMA buffer address
at003:
push ax           ;set the cursor position
push ds
mov ax,cs
mov ds,ax
mov ah,2
mov bh,0
mov dl,12
mov dh,20
int 10h
mov ax,[blockno]  ;Increment the number of the block
inc ax
mov [blockno],ax
mov dx,0
decimal           ;write the block number to the CRT
pop ds
pop ax
mov bx,[fileno]   ;read the file block to the buffer; first 32kB part
mov ds,ax
mov dx,0
mov cx,32768
mov ax,3F00h
int 21h
jc ferror
cmp ax,32768      ;is it the last block?
jnz utolso
mov ax,3F00h      ;read the file block to the buffer; second 32kB part
mov dx,32768
int 21h
jc ferror
cmp ax,32768      ;is it the last block?
jnz utolso
mov bx,cs
mov ds,bx
mov dx,0ffffh
mov [blocksize],dx;save the loaded block size
ret
utolso:           ;if it's the last block, tzhen save the block size and
mov bx,cs         ;set the lastblock flag
mov ds,bx
add dx,ax
mov [blocksize],dx
mov bl,1
mov [lastblock],bl
ret
ferror:          ;file error ->abort
pop ax
puteol
putbs 0,err2
jmp vege

save1:;---------------------Save the first block----------------------------
;Save the next 64kB block of the file from the DMA buffer lower area
mov ax,[poi]
jmp at102
save2:;--------------------Save the second block----------------------------
;Save the next 64kB block of the file from the DMA buffer higher area
mov ax,[poi]
add ax,4096
at102:
push ax              ;set cursor position
mov ah,2
mov bh,0
mov dl,12
mov dh,20
int 10h
mov ax,[blockno]     ;increment block number
inc ax
mov [blockno],ax
mov dx,0
decimal             ;write the block number to the CRT
pop ax
mov bx,[fileno]     ;Save the first part of the block
mov ds,ax
mov dx,0
mov cx,32768
mov ah,40h
int 21h
jc ferrorw
mov dx,32768       ;Save the second part of the block
mov cx,32768
mov ah,40h
int 21h
jc ferrorw
mov ax,cs
mov ds,ax
ret
ferrorw:          ;File error aborts the program
pop ax
puteol
putbs 0,err4
jmp vege

kb_wait:;------------------Waiting for interrupt or kbhit-------------------
;Waiting for interrupt or keystroke. In case of a keystroke call the
;keyboard handling routine.
mov ax,cs
mov ds,ax
waiting:              ;Polling cycle
mov al,[flag]         ;Was there an interrupt?
cmp al,1
jz nextblock
mov ah,0Bh            ;Was there a keystroke?
int 21h
cmp al,0FFh
jnz waiting           ;If not then continue polling.
mov al,[play_flag]    ;playing or recording?
cmp al,1
jz play001
call bill_r           ;Call keyboard routine written for recording
jmp at998
play001:
call bill             ;Call keyboard routine written for playing
at998:
jmp waiting           ;Continue polling
nextblock:
mov al,0              ;Delete interrupt flag
mov [flag],al
ret

set_play:;----------------------Start playing-----------------------------
;Start playing the first 64kB block set the DMA and the DSP
;DMA SETTING         ;for lower block bx=0 , for upper block bx=4096
mov al,05h
out 0Ah,al           ;disable DMA channel1
mov al,0
out 0Ch,al           ;Clear the internal DMA flip-flop
mov al,49h
out 0Bh,al           ;Set the mode register: Single mode, read from mem.
mov ax,[poi]         ;compute the address
add ax,bx
mov bx,16
mul bx               ;dx:ax= linear address
out 02h,al           ;lin addr lower 8 bit
mov al,ah
out 02h,al           ;lin addr next  8  bit
mov al,dl
out 83h,al           ;write the page register
mov al,[blocksize]
out 03h,al           ;size low
mov al,[blocksize+1]
out 03h,al           ;size high
mov al,01h
out 0Ah,al           ;enable DMA channel1
;DSP SETTING
mov al,40h           ;set the sample rate
call writedsp
mov dx,15
mov ax,16960
mov bx,[freq]
div bx
mov dx,256
sub dx,ax
mov al,dl
call writedsp        ;data= 256 - 1 000 000 Div Freq
mov al,14h           ;8 bit playing with DMA
call writedsp
mov al,[blocksize]   ;size low
call writedsp
mov al,[blocksize+1] ;size high
call writedsp
ret

set_record:;----------------------Start recording----------------------------
;Start recording the first 64kB block set the DMA and the DSP
;DMA SETTING         ;for lower block bx=0 , for upper block bx=4096
mov ax,cs
mov ds,ax
cmp bx,0             ;lower or upper block?
jz sr_l
mov al,2
mov [phase],al       ;phase=2 if upper block
jmp at898
sr_l:
mov al,1
mov [phase],al       ;phase=1 if lower block
at898:
mov al,05h
out 0Ah,al           ;disable DMA channel1
mov al,0
out 0Ch,al           ;Clear the internal DMA flip-flop
mov al,45h
out 0Bh,al           ;Set the mode register: single mode, write mem.
mov ax,[poi]         ;compute the address
add ax,bx
mov bx,16
mul bx               ;dx:ax= linear address
out 02h,al           ;lin addr lower 8 bit
mov al,ah
out 02h,al           ;lin addr next  8  bit
mov al,dl
out 83h,al           ;write the page register
mov al,[blocksize]
out 03h,al           ;size low
mov al,[blocksize+1]
out 03h,al           ;size high
mov al,01h
out 0Ah,al           ;enable DMA channel1
;DSP SETTING
mov al,40h           ;set the sample rate
call writedsp
mov dx,15
mov ax,16960
mov bx,[freq]
div bx
mov dx,256
sub dx,ax
mov al,dl
call writedsp        ;256 - 1 000 000 Div Freq
mov al,24h           ;8 bit recording with DMA
call writedsp
mov al,[blocksize]   ;size low
call writedsp
mov al,[blocksize+1] ;size high
call writedsp
ret

start:;************************* MAIN START********************************
;The program starts here
;INTERRUPT SETTINGS
cli
xor ax,ax           ;save and set interrupt vector
mov ds,ax           ;DS=0
mov ax,[0Dh*4]      ;Save the IRQ5 interrupt vector
mov [es:mszak],ax
mov ax,[0Dh*4+2]
mov [es:mszak+2],ax
mov ax,inte          ;Set the IRQ5 interrupt vector to the inte IT routine
mov [0Dh*4],ax
mov [0Dh*4+2],cs
mov bx,cs
mov ds,bx
in al,21h            ;set interrupt mask register
mov [mask],al        ;save mask
and al,11011111b
out 21h,al           ;set mask , IRQ5 = Enabled
sti
;SET DISPLAY, RESET CARD
clrscr              ;clear screen
call initsound      ;sound card DSP reset
call setmixer       ;set the sound mixer
;ALLOCATE MEMORY
mov ax,4A00h        ;memory rename : CODE SEGMENT=64kB
mov bx,4096
int 21h
push cs             ;Set the stack
pop ss
mov ax,0fffeh
mov sp,ax
jc mhiba
mov ax,4800h        ; asking for 192kB memory
mov bx,12288
int 21h
jc mhiba            ;ax=pointer
mov bx,cs
mov ds,bx
mov [mem],ax        ;save the mem pointer
add ax,4096         ;computing the DMA puffer address
mov dx,0            ;DMAseg=((allocated_seg)div 4096)*4096
mov bx,4096
div bx
mul bx
mov [poi],ax        ;save the pointer
jmp at001
mhiba:              ;memory error
putbs 0,err1
end                 ;abort
at001:

call keret          ;draw the frame
;WAIT FOR KBHIT
ask_bill:           ;Ask Bios for the keycode
mov ax,0
int 16h
cmp al,27           ;ESC
jz kilep1
cmp al,'s'
jz sample1
cmp al,'0'
jz open1
cmp al,'o'
jz open1
cmp ah,80           ;down
jz play1
cmp al,8            ;backspace
jz record1
jmp ask_bill
kilep1:             ;exit from the program
clrscr
jmp vege
sample1 call sample ;set sample rate
jmp ask_bill
open1: call open    ;input file name
jmp ask_bill
vissza:
ring
jmp ask_bill
;Initialize playing, the down arrow was hit
play1:
mov ax,cs            ;Is there any file to open?
mov ds,ax
mov al,[file]
cmp al,0
jz vissza            ;If there isn't any file to open then go back
call delwin          ;clear the left part of the window
setcolor 15
puts 10,10,pl_sz     ;Put the string 'PLAYING'
mov al,1
mov [play_flag],al   ;set the playing flag
jmp start_play
;Initialize recording, the backspace was hit
record1:             ;Recording init
mov ax,cs
mov ds,ax
mov ax,0ffffh
mov [blocksize],ax   ;init the block size
mov al,[file]        ;If there is no file to record to then go back
cmp al,0
jz vissza
mov al,1
mov [record_flag],al ;set the recording flag
mov al,0
mov [flag],al        ;Delete the interrupt flag
call delwin          ;Put the string 'RECORDING' to the CRT
setcolor 15
puts 10,10,rec_sz
;RECORDING
mov dx,22Eh         ;read the state reg of the Card, delete IT flag
in al,dx
setcolor 15         ;block display
puts 5,20,bck
mov ah,2             ;set cursor position
mov bh,0
mov dl,12
mov dh,20
int 10h
mov ax,1
mov [blockno],ax     ;initilize block number
mov dx,0
mov ax,1
decimal              ;print block number
mov ah,3Ch           ;open a file to write
mov dx,file
mov cx,0
int 21h
jc fo_error1
jmp at345
fo_error1: jmp fo_error;file error
at345:
mov [fileno],ax
cld                   ;zero low block of DMA buffer
push es
mov ax,[poi]
mov es,ax
mov ax,8080h
mov cx,32768
mov di,0
rep stosw
mov ax,[poi]         ;zero high block of DMA buffer
add ax,4096
mov es,ax
mov ax,8080h
mov cx,32768
mov di,0
rep stosw
pop es
mov bx,0
call set_record      ;Digitalize to the first block
;*****************Init for playing**************************************
;digitalize to the lower block
record:
call kb_wait          ;Wait for IT or keystroke
call save1            ;save the first block
mov bx,4096
call set_record       ;digitalize to the second block
cld                   ;zero lower block
push es
mov ax,[poi]
mov es,ax
mov ax,8080h
mov cx,32768
mov di,0
rep stosw
pop es
call kb_wait           ;Wait for IT or keystroke
call save2             ;save the second block
mov bx,0
call set_record        ;digitalize to the first block
cld                    ;zero upper block
push es
mov ax,[poi]
add ax,4096
mov es,ax
mov ax,8080h
mov cx,32768
mov di,0
rep stosw
pop es
jmp record            ;continue the recording cycle

start_play:          ;playing the file 
;SET THE CURSOR
setcolor 15          ;print the block number
puts 5,20,bck
mov ah,2             ;set cursor position
mov bh,0
mov dl,12
mov dh,20
int 10h
mov ax,0ffffh        ;initialize block number
mov [blockno],ax
mov dx,0
mov ax,1
decimal              ;print the block number
;READ THE FILE
mov ax,3d00h        ;open the file
mov dx,file
int 21h
jc fo_error
jmp at009
fo_error:           ;opening error: sign the error and go back
ring                ;warning ring
call delwin         ;delete window
setcolor 15
puts 10,20,err3     ;print error messege
delay 200,0ffffh    ;delay a second
call delwin         ;restore window
setcolor 15
puts 5,10,sz5
jmp ask_bill        ;go back
at009:
mov [fileno],ax     ;save the file number
mov bx,ax
mov ah,3fh
mov dx,puffer1
mov cx,100
int 21h              ;read the .wav file header ,about 100 byte
jc ferror1
jmp at006
ferror1: push ax     ;file error
jmp ferror
at006:
call read_low        ;read the file to the first part of the DMA buffer
mov al,[lastblock]   ;if the file ended don't read more
cmp al,1
jz at004
call read_high       ;read the next file block to the DMA buffer
at004:
;PLAY THE FIRST BLOCK
call speakeron       ;switch on the speaker
mov bx,0
call set_play        ;start the playing  (lower block)
mov al,1             ;lower block
mov [block_ud],al
mov al,[lastblock]   ;last block played?
cmp al,1
jz end_play          ;exit from playing blocks

;**********************************MAIN PLAYING CICLE***********************
playing:
call kb_wait       ;waiting for IT or keystroke
;PLAY BLOCK2
mov bx,4096
call set_play      ;start the playing (upper block)
mov al,2           ;upper block
mov [block_ud],al
mov al,[lastblock] ;last block?
cmp al,1
jz end_play
call read_low      ;load block1
call kb_wait       ;waiting for IT or keystroke
;PLAY BLOCK1
mov bx,0
call set_play      ;start the playing (lower block)
mov al,1           ;lower block
mov [block_ud],al
mov al,[lastblock] ;last block?
cmp al,1
jz end_play
call read_high     ;load block2
jmp playing

end_play:          ; end of the playing
;CLOSE THE FILE
mov ax,cs
mov ds,ax
mov ah,3Eh
mov bx,[fileno]
int 21h
jc ferror2         ;Error closing the file
jmp at008
ferror2: push ax
jmp ferror         ;abort
at008:
;WAITING
call kb_wait       ;waiting for interrupt or keystroke
mov al,05h         ;disable DMA
out 0Ah,al         ;DMA mask
abort_play:
call delwin        ;restore screen
setcolor 15
puts 5,10,sz5
mov ax,cs
mov ds,ax
xor ax,ax          ;reset variables for the next playing
mov [flag],al
mov [lastblock],al
mov [play_flag],al
mov ax,0FFFFh
mov [blocksize],ax
jmp ask_bill       ;Jump into the keyboard polling cycle

vege:              ;Exiting from the program
;FREE MEMORY
mov ax,cs
mov ds,ax
mov ax,4900h
mov bx,[mem]
mov es,bx
int 21h
jc mhiba1
;RESTORE INTERRUPT VECTOR AND MASK
xor ax,ax
mov ds,ax
push cs
pop es
cli
mov ax,[es:mszak]    ;restore IRQ5 vector
mov [0Dh*4],ax
mov ax,[es:mszak+2]
mov [0Dh*4+2],ax
mov ax,cs
mov ds,ax
mov al,[mask]       ;restore interrupt mask (8259)
out 21h,al
sti
end
mhiba1: jmp mhiba   ;memory allocation error

puffer1:            ;puffer for the .wav header